#ifndef __BZ_NATEON_H__
#define __BZ_NATEON_H__

#include <glib.h>
#include <internal.h>
#include <accountopt.h>

#include <plugin.h>
#include <pluginpref.h>
#include <prpl.h>
#include <gaim_buffer.h>
#include <version.h>
#include <util.h>
#include <debug.h>

#include "buddy.h"

#define NATEON_SERVER "dpl.nate.com"
#define NATEON_PORT 5004

#define NATEON_INIT_BUFSIZE 512

enum
{
	NATEON_TRID_SET  = -1,
	NATEON_TRID_ZERO = 0,
	NATEON_TRID_CUR  = 1
};

#define NATEON_STEP 9
enum
{
	NATEON_STEP_CONN = 0,
	NATEON_STEP_PVER,
	NATEON_STEP_AUTH,
	NATEON_STEP_REQS,
	NATEON_STEP_LSIN,
	NATEON_STEP_GLST,
	NATEON_STEP_LIST,
	NATEON_STEP_CHSTAT,
	NATEON_STEP_ONLINE
};

typedef struct _NateConn
{
	GaimAccount* account;

	char* host;
	int   port;

	int   fd;
	int   trid;
	int   curstep;
	
	char* read_buffer;
	int   read_buflen;
	int   read_bufused;

	guint           write_handler;
	GaimCircBuffer* write_buffer;

	GHashTable* msg_table;
	
	NateBuddy* buddy_list;
	//GHashTable* chatroom;
} NateConn;

void nateon_login(GaimAccount* account);
void nateon_login_cb(gpointer data, gint source, GaimInputCondition cond);
void nateon_close(GaimConnection* gc);
void nateon_write(NateConn* Nateon, const char* buf);
void nateon_write_cb(gpointer data, gint source, GaimInputCondition cond);
void nateon_read(NateConn* Nateon);
void nateon_read_cb(gpointer data, gint source, GaimInputCondition cond);

GList* nateon_stat_type(GaimAccount* account);
const char* nateon_list_icon(GaimAccount* a, GaimBuddy* b);
void nateon_list_emblems(GaimBuddy* b, const char** se, const char** sw, const char** nw, const char** ne);
void nateon_set_status(GaimAccount* acoount, GaimStatus* status);
GList* nateon_status_types(GaimAccount* account);

void nateon_sendpacket(NateConn* Nateon, const char* cmnd, int trid, const char* format, ...);
char* nateon_get_trid(NateConn* Nateon, int trid);

gboolean nateon_set_current_step(NateConn* Nateon, int step);
#endif
