#!/usr/bin/env python
# -*- coding: utf-8 -*-

# sayclub client implementation stub
# By Park J. K. <nemesis at planetmono dot org>

import urllib, socket
import sys, os
import random
import base64
import re

import uuid, timeoutsocket
from PHPSerial import *

req = {}
BUF_SIZE = 2**14
TIMEOUT = 2

user_id = ''
user_pw = ''

# subroutines
def undef_exit():
	print 'Error: Unhandled exception.'
	sys.exit(1)

def str_exit(exit_str):
	print 'Error: '+exit_str
	sys.exit(1)

def get_macaddr():
	from os.path import join, isfile
	from os import popen
	
	for dir in ['/sbin', '/usr/sbin', r'c:\windows', r'c:\windows\system', r'c:\windows\system32']:
		if isfile(join(dir, 'ifconfig')): # unix 
			program = join(dir, 'ifconfig')
			for line in popen(program+' eth0'):
				words = line.lower().split()
				if 'hwaddr' in words:
					addr = words[words.index('hwaddr') + 1]
					return addr.replace(':', '')
				if 'ether' in words:
					addr = words[words.index('ether') + 1]
					return addr.replace(':', '')
		if isfile(join(dir, 'ipconfig.exe')):
			program = join(dir, 'ipconfig.exe')
			for line in popen(program + ' /all'):
				if line.strip().lower().startswith('physical address'):
					addr = line.split(':')[-1].strip()
					return addr.replace('-', '')

def get_ipaddr():
	from os.path import join, isfile
	from os import popen
	
	for dir in ['/sbin', '/usr/sbin', r'c:\windows', r'c:\windows\system', r'c:\windows\system32']:
		if isfile(join(dir, 'ifconfig')): # unix 
			program = join(dir, 'ifconfig')
			for line in popen(program+' eth0'):
				words = line.lower().split()
				if 'inet' in words:
					addr = words[words.index('inet') + 1]
					return addr[5:]
		if isfile(join(dir, 'ipconfig.exe')):
			program = join(dir, 'ipconfig.exe')
			for line in popen(program + ' /all'):
				if line.strip().lower().startswith('ip address'):
					addr = line.split(':')[-1].strip()
					return addr

def call_serial(sock, method, array, encoding=None):
	global req
	
	param = PHPSerial().serialize(array, encoding)
	
	reqno = str(random.randrange(10000000, 99999999))
	while req.has_key(reqno):
		reqno = str(random.randrange(10000000, 99999999))
	req[reqno] = param

	sock.send('APPSVR_CALL_SERIAL method LOGINE:%s &method_name=%s&arrparam=%s\n' % (reqno, method, urllib.quote(param)))
	
	return reqno

def flush_request(reqno):
	global req
	del req[reqno]

def get(sock):
	sock.set_timeout()
	output = ''
	data = ''
	while True:
		try:
			data = sock.recv(BUF_SIZE)
			output += data
			sock.set_timeout(0.2)
		except timeoutsocket.Timeout: break
	
	return output

def fetch_call(data, callid):
	start = None
	end = None
	output = ''
	for line in data.split('\n'):
		if 'APPSVR_RESULT BEGIN LOGINE:'+callid in line: start = 1
		elif start == 1 and 'APPSVR_RESULT END LOGINE:'+callid in line: end = 1
		elif start == 1 and 'APPSVR_RESULT DATA LOGINE:'+callid in line:
			output += line[35:]
	
	if start == 1 and end == 1:
		try:
			return base64.b64decode(output)
		except TypeError:
			return None
	else:
		return None

def pong(sock, data):
	for line in data.split('\n'):
		if line.startswith('PING'):
			sock.send('PONG '+line.split()[1]+'\n')

def get_array(data, not_response = None):
	if not_response == None: result = fetch_call(data, callid)
	else: result = data
	try: array = PHPSerial().unserialize(result, 'cp949')
	except Exception, e:
		raise Exception('Error decoding serialized data: '+str(e))
	
	if array.has_key('errcode') and len(array['arrerrcode']) != 0:
		raise Exception(('Errornous Request: '+array['errstr']).encode('utf-8')+' ('+str(array['errcode'])+')')
	
	return array

def notify_event(notify):
	global msrl
	
	if notify.startswith('NOTIFY'):
		data = get_array(urllib.unquote(notify[7:].replace('+', ' ')).strip(), '1')
		if data['notify_type'] == 'FRIENDINOUT':
			if data['action'] == 'login':
				msrl[data['sendermsrl']]['onlinestatus'] = '1'
				txt = 'Online'
			elif data['action'] == 'logout':
				msrl[data['sendermsrl']]['onlinestatus'] = ''
				txt = 'Offline'
			print '* '+msrl[data['sendermsrl']]['dusername']+'('+msrl[data['sendermsrl']]['usrid']+') Goes '+txt+'.'
		elif data['notify_type'] == 'INFOCHG':
			msrl[data['sendermsrl']]['onlinestatus'] = data['onlinestatus']
			msrl[data['sendermsrl']]['mood'] = data['mood']
			msrl[data['sendermsrl']]['mynoti'] = data['mynoti']
			msrl[data['sendermsrl']]['dusername'] = data['friendname']
			print '* Changed Information: '+msrl[data['sendermsrl']]['dusername']+'('+msrl[data['sendermsrl']]['usrid']+') - '+msrl[data['sendermsrl']]['mynoti']
		elif data['notify_type'] == 'MEMO':
			if data['sendermsrl'] in msrl:
				sender = msrl[data['sendermsrl']]['dusername']+'('+msrl[data['sendermsrl']]['usrid']+')'
			else:
				sender = data['sendername']+'('+data['senderid']+')'
			print '* '+sender+' :: '+data['content']
		else:
			print '* Unhandled event: \''+data['notify_type']+'\''

# variable def
server = '211.115.85.131'
server_port = 6699

user_keyno = str(random.randrange(100000, 999999))
user_key = '%s%s' % (user_id, user_keyno)
user_uuid = str(uuid.uuid1())[1:37]
user_ip = get_ipaddr()
user_mac = get_macaddr()

# main
if not user_id or not user_pw:
	str_exit('No ID/Password! Set user_id, user_pw variable.')

print 'Connecting'

sock = timeoutsocket.timeoutsocket(socket.AF_INET, socket.SOCK_STREAM)
sock.connect((server, server_port))

print 'Authenticating'

data = get(sock)
if not data or data != 'IRCR_HELLO\n':
	sock.close()
	undef_exit()

query = u'IRCR_KEY %s\nIRCR_NICK %s\nPEER_SWITCH IM_SESSION\n' % (user_key, user_id)
sock.send(query.encode('cp949'))

data = get(sock)
if u'등록되지 않은 사용자 입니다.' in unicode(data, 'cp949'):
	sock.close()
	str_exit('No ID!')
elif 'PEER_SWITCH FAILED' in data:
	sock.close()
	undef_exit()

param_myip = ''
param_myport = 0
param_udpport = 0
param_svrtime = 0
for line in data.split('\n'):
	if line.startswith('MYIP :'):
		param_myip = line[line.find(':')+1:].strip()
	elif line.startswith('MYPORT :'):
		param_myport = int(line[line.find(':')+1:].strip())
	elif line.startswith('UDPPORT :'):
		param_udpport = int(line[line.find(':')+1:].strip())
	elif line.startswith('SVRTIME :'):
		param_svrtime = int(line[line.find(':')+1:].strip())

if not param_myip or not param_myport or not param_udpport or not param_svrtime:
	sock.close()
	undef_exit()

sock.send('IRCR_OPTIONSET APPSVR_REQURL_SERIAL :/im/phpserver/imserver2.nwz\n\n')

callid = call_serial(sock, 'request_login', {'myip':param_myip, 'method':'request_login', 'force':'0', 'clientip':user_ip, 'key':user_key, 'usrid':user_id, 'uuid':user_uuid, 'myport':str(param_myport), 'checkpw':'0', 'macaddress':user_mac, 'passwd':user_pw})
output = ''
while True:
	data = get(sock)
	output += data
	if data[-1] != '\n': continue
	if 'APPSVR_RESULT END' in data: break
pong(sock, output)
try: result = get_array(output)
except Exception, e:
	sock.close()
	str_exit(str(e))
flush_request(callid)

print 'Logged in successfully.'

callid = call_serial(sock, 'request_startinfo', {'method':'request_startinfo'})
print callid
output = ''
while True:
	data = get(sock)
	output += data
	if data[-1] != '\n': continue
	if 'APPSVR_RESULT END' in data: break
pong(sock, output)
try: array = get_array(output)
except Exception, e:
	sock.close()
	str_exit(str(e))
flush_request(callid)

print '\nFriendlist'

msrl = {}
for x in range(0, len(array['FRIENDLIST'])):
	msrl[unicode(array['FRIENDLIST'][x]['msrl'])] = array['FRIENDLIST'][x]

for x in range(0, len(array['GROUPLIST'])):
	print array['GROUPLIST'][x]['groupname']
	for y in array['GROUPLIST'][x]['flist']:
		if msrl[unicode(y)].has_key('onlinestatus'):
			if msrl[unicode(y)]['onlinestatus'] == '1':
				os = ' (Online)'
			elif msrl[unicode(y)]['onlinestatus'] == '2':
				os = ' (Away)'
			elif msrl[unicode(y)]['onlinestatus'] == '3':
				os = ' (Busy)'
			elif msrl[unicode(y)]['onlinestatus'] == '':
				os = ' (Offline)'
		else:
			os = ' (Offline)';
		print '  '+msrl[str(y)]['dusername']+'('+msrl[str(y)]['usrid']+':'+str(y)+') - '+msrl[str(y)]['mynoti']+os

while True:
	output = ''
	while True:
		data = get(sock)
		output += data
		if data[-1] != '\n': continue
		else: break
	pong(sock, data)
	notify_event(data)

sock.close()
